#pragma config(Sensor, in1,    UpperPent,      sensorPotentiometer)
#pragma config(Sensor, in2,    LowerPent,      sensorPotentiometer)
#pragma config(Sensor, I2C_1,  ,               sensorQuadEncoderOnI2CPort,    , AutoAssign )
#pragma config(Sensor, I2C_2,  ,               sensorQuadEncoderOnI2CPort,    , AutoAssign )
#pragma config(Sensor, I2C_3,  ,               sensorQuadEncoderOnI2CPort,    , AutoAssign )
#pragma config(Motor,  port1,           BaseBackLeft,  tmotorVex393HighSpeed_HBridge, openLoop, driveLeft, encoderPort, I2C_1)
#pragma config(Motor,  port2,           BaseFrontLeft, tmotorVex393HighSpeed_MC29, openLoop, driveLeft)
#pragma config(Motor,  port3,           ArmUpperMiddleLeft, tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port4,           ArmLowerMiddleLeft, tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port5,           ArmOuterLeft,  tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port6,           ArmOuterRight, tmotorVex393_MC29, openLoop, encoderPort, I2C_3)
#pragma config(Motor,  port7,           ArmUpperMiddleRight, tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port8,           ArmLowerMiddleRight, tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port9,           BaseFrontRight, tmotorVex393HighSpeed_MC29, openLoop, driveRight)
#pragma config(Motor,  port10,          BaseBackRight, tmotorVex393HighSpeed_HBridge, openLoop, driveRight, encoderPort, I2C_2)

#pragma platform(VEX)

#pragma competitionControl(Competition)
#pragma autonomousDuration(15)
#pragma userControlDuration(105)

#include "Vex_Competition_Includes.c"

//Code by Brendan Root(Everything but some of the autonomous) AND Joseph Gage(Some of the autonomous), Do not claim code as own. You can ignore this stuff^^

//-----------------------------Declare Special User-Made Redundant Methods------------------------------
//These are for doing various functions during autonomous, they are all the random things that we may need to do, just read each one to see what they do.

//Redundant coding for arm, just call arm(motor power)
void arm(int power)
{
	motor[ArmLowerMiddleLeft] = power;
	motor[ArmLowerMiddleRight] = power;
	motor[ArmOuterLeft] = power;
	motor[ArmOuterRight] = power;
	motor[ArmUpperMiddleLeft] = power;
	motor[ArmUpperMiddleRight] = power;
}

//Redundant coding for resetting encoders, just call resetMotorEncoders()
void resetMotorEncoders()
{
	nMotorEncoder[BaseBackLeft] = 0;
	nMotorEncoder[BaseBackRight] = 0;
	nMotorEncoder[ArmOuterRight] = 0;
}

//Redundant coding for driving forward, just call driveForward(motor power, sensor amount)
void driveForward(int power, int amount)
{
	while(nMotorEncoder[BaseBackLeft] < amount || nMotorEncoder[BaseBackRight] > -amount)
	{
		if(nMotorEncoder[BaseBackLeft] < amount)
		{
			motor[BaseBackLeft] = power;
			motor[BaseFrontLeft] = power;
		}
		else
		{
			motor[BaseBackLeft] = 0;
			motor[BaseFrontLeft] = 0;
		}
		if(nMotorEncoder[BaseBackRight] > -amount)
		{
			motor[BaseBackRight] = power;
			motor[BaseFrontRight] = power;
		}
		else
		{
			motor[BaseBackRight] = 0;
			motor[BaseFrontRight] = 0;
		}
	}
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
}

//Redundant coding for driving backward, just call driveBackward(motor power, sensor amount)
void driveBackward(int power, int amount)
{
	while(nMotorEncoder[BaseBackLeft] > -amount || nMotorEncoder[BaseBackRight] < amount)
	{
		if(nMotorEncoder[BaseBackLeft] > -amount)
		{
			motor[BaseBackLeft] = -power;
			motor[BaseFrontLeft] = -power;
		}
		else
		{
			motor[BaseBackLeft] = 0;
			motor[BaseFrontLeft] = 0;
		}
		if(nMotorEncoder[BaseBackRight] < amount)
		{
			motor[BaseBackRight] = -power;
			motor[BaseFrontRight] = -power;
		}
		else
		{
			motor[BaseBackRight] = 0;
			motor[BaseFrontRight] = 0;
		}
	}
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
}

//Redundant coding for rotating right, just call rotateRight(motor power, sensor amount)
void rotateRight(int power, int amount)
{
	while(nMotorEncoder[BaseBackLeft] < amount || nMotorEncoder[BaseBackRight] < amount)
	{
		if(nMotorEncoder[BaseBackLeft] < amount)
		{
			motor[BaseBackLeft] = power;
			motor[BaseFrontLeft] = power;
		}
		else
		{
			motor[BaseBackLeft] = 0;
			motor[BaseFrontLeft] = 0;
		}
		if(nMotorEncoder[BaseBackRight] < amount)
		{
			motor[BaseBackRight] = -power;
			motor[BaseFrontRight] = -power;
		}
		else
		{
			motor[BaseBackRight] = 0;
			motor[BaseFrontRight] = 0;
		}
	}
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
}

//Redundant coding for rotating left, just call rotateLeft(motor power, sensor amount)
void rotateLeft(int power, int amount)
{
	while(nMotorEncoder[BaseBackLeft] > -amount || nMotorEncoder[BaseBackRight] > -amount)
	{
		if(nMotorEncoder[BaseBackLeft] > -amount)
		{
			motor[BaseBackLeft] = -power;
			motor[BaseFrontLeft] = -power;
		}
		else
		{
			motor[BaseBackLeft] = 0;
			motor[BaseFrontLeft] = 0;
		}
		if(nMotorEncoder[BaseBackRight] > -amount)
		{
			motor[BaseBackRight] = power;
			motor[BaseFrontRight] = power;
		}
		else
		{
			motor[BaseBackRight] = 0;
			motor[BaseFrontRight] = 0;
		}
	}
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
}

//Redundant coding for lifting arm, just call liftArm(motor power, sensor amount)
void liftArm(int power, int amount)
{
	while(nMotorEncoder[ArmOuterRight] < amount)
	{
		arm(power);
	}
	arm(0);
}

//Redundant coding for lowering arm, just call lowerArm(motor power, sensor amount)
void lowerArm(int power, int amount)
{
	while(nMotorEncoder[ArmOuterRight] > -amount)
	{
		arm(-power);
	}
	arm(0);
}

//Redundant coding for driving backward and lifting arm, just call driveBackwardLift(base motor power, base sensor amount, arm motor power, arm sensor amount)
void driveBackwardLift(int basePower, int baseAmount, int armPower, int armAmount)
{
	while(nMotorEncoder[BaseBackLeft] > -baseAmount || nMotorEncoder[BaseBackRight] < baseAmount || nMotorEncoder[ArmOuterRight] < armAmount)
	{
		if(nMotorEncoder[BaseBackLeft] > -baseAmount)
		{
			motor[BaseBackLeft] = -basePower;
			motor[BaseFrontLeft] = -basePower;
		}
		else
		{
			motor[BaseBackLeft] = 0;
			motor[BaseFrontLeft] = 0;
		}
		if(nMotorEncoder[BaseBackRight] < baseAmount)
		{
			motor[BaseBackRight] = -basePower;
			motor[BaseFrontRight] = -basePower;
		}
		else
		{
			motor[BaseBackRight] = 0;
			motor[BaseFrontRight] = 0;
		}
		if(nMotorEncoder[ArmOuterRight] < armAmount)
		{
			arm(armPower);
		}
		else
		{
			arm(0);
		}
	}
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
	arm(0);
}

//Redundant coding for driving forward and lifting arm, just call driveForwardLift(base motor power, base sensor amount, arm motor power, arm sensor amount)
void driveForwardLift(int basePower, int baseAmount, int armPower, int armAmount)
{
	while(nMotorEncoder[BaseBackLeft] < baseAmount || nMotorEncoder[BaseBackRight] > -baseAmount || nMotorEncoder[ArmOuterRight] < armAmount)
	{
		if(nMotorEncoder[BaseBackLeft] < baseAmount)
		{
			motor[BaseBackLeft] = basePower;
			motor[BaseFrontLeft] = basePower;
		}
		else
		{
			motor[BaseBackLeft] = 0;
			motor[BaseFrontLeft] = 0;
		}
		if(nMotorEncoder[BaseBackRight] > -baseAmount)
		{
			motor[BaseBackRight] = basePower;
			motor[BaseFrontRight] = basePower;
		}
		else
		{
			motor[BaseBackRight] = 0;
			motor[BaseFrontRight] = 0;
		}
		if(nMotorEncoder[ArmOuterRight] < armAmount)
		{
			arm(armPower);
		}
		else
		{
			arm(0);
		}
	}
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
	arm(0);
}

//Redundant coding for driving forward and lowering arm, just call driveForwardLower(base motor power, base sensor amount, arm motor power, arm sensor amount)
void driveForwardLower(int basePower, int baseAmount, int armPower, int armAmount)
{
	while(nMotorEncoder[BaseBackLeft] < baseAmount || nMotorEncoder[BaseBackRight] > -baseAmount || nMotorEncoder[ArmOuterRight] > -armAmount)
	{
		if(nMotorEncoder[BaseBackLeft] < baseAmount)
		{
			motor[BaseBackLeft] = basePower;
			motor[BaseFrontLeft] = basePower;
		}
		else
		{
			motor[BaseBackLeft] = 0;
			motor[BaseFrontLeft] = 0;
		}
		if(nMotorEncoder[BaseBackRight] > -baseAmount)
		{
			motor[BaseBackRight] = basePower;
			motor[BaseFrontRight] = basePower;
		}
		else
		{
			motor[BaseBackRight] = 0;
			motor[BaseFrontRight] = 0;
		}
		if(nMotorEncoder[ArmOuterRight] > -armAmount)
		{
			arm(-armPower);
		}
		else
		{
			arm(0);
		}
	}
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
	arm(0);
}

//Redundant coding for driving backward and lowering arm, just call driveBackwardLower(base motor power, base sensor amount, arm motor power, arm sensor amount)
void driveBackwardLower(int basePower, int baseAmount, int armPower, int armAmount)
{
	while(nMotorEncoder[BaseBackLeft] > -baseAmount || nMotorEncoder[BaseBackRight] < baseAmount || nMotorEncoder[ArmOuterRight] > -armAmount)
	{
		if(nMotorEncoder[BaseBackLeft] > -baseAmount)
		{
			motor[BaseBackLeft] = -basePower;
			motor[BaseFrontLeft] = -basePower;
		}
		else
		{
			motor[BaseBackLeft] = 0;
			motor[BaseFrontLeft] = 0;
		}
		if(nMotorEncoder[BaseBackRight] < baseAmount)
		{
			motor[BaseBackRight] = -basePower;
			motor[BaseFrontRight] = -basePower;
		}
		else
		{
			motor[BaseBackRight] = 0;
			motor[BaseFrontRight] = 0;
		}
		if(nMotorEncoder[ArmOuterRight] > -armAmount)
		{
			arm(-armPower);
		}
		else
		{
			arm(0);
		}
	}
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
	arm(0);
}

//Redundant coding for quickly stopping right rotations, just call stopRotateRight()
void stopRotateRight()
{
	motor[BaseBackLeft] = 127;
	motor[BaseFrontLeft] = 127;
	motor[BaseBackRight] = -127;
	motor[BaseFrontRight] = -127;
	wait1Msec(20);
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
}

//Redundant coding for quickly stopping left rotations, just call stopRotateLeft()
void stopRotateLeft()
{
	motor[BaseBackLeft] = -127;
	motor[BaseFrontLeft] = -127;
	motor[BaseBackRight] = 127;
	motor[BaseFrontRight] = 127;
	wait1Msec(20);
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
}

//Redundant coding for quickly stopping driving forward, just call stopDriveForward()
void stopDriveForward()
{
	motor[BaseBackLeft] = -127;
	motor[BaseFrontLeft] = -127;
	motor[BaseBackRight] = -127;
	motor[BaseFrontRight] = -127;
	wait1Msec(60);
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
}

//Redundant coding for quickly stopping driving backward, just call stopDriveBackward()
void stopDriveBackward()
{
	motor[BaseBackLeft] = 127;
	motor[BaseFrontLeft] = 127;
	motor[BaseBackRight] = 127;
	motor[BaseFrontRight] = 127;
	wait1Msec(60);
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
}

//Redundant coding for quickly stopping lowering arm, just call stopLowerArm()
void stopLowerArm()
{
	arm(127);
	wait1Msec(20);
	arm(0);
}

//Redundant coding for quickly stopping driving backward and lowering the arm, just call stopDriveBackwardLower()
void stopDriveBackwardLower()
{
	motor[BaseBackLeft] = 127;
	motor[BaseFrontLeft] = 127;
	motor[BaseBackRight] = 127;
	motor[BaseFrontRight] = 127;
	arm(127);
	wait1Msec(20);
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
	arm(0);
}

//Redundant coding for quickly stopping driving forward and lowering the arm, just call stopDriveForwardLower()
void stopDriveForwardLower()
{
	motor[BaseBackLeft] = -127;
	motor[BaseFrontLeft] = -127;
	motor[BaseBackRight] = -127;
	motor[BaseFrontRight] = -127;
	arm(127);
	wait1Msec(30);
	motor[BaseBackLeft] = 0;
	motor[BaseFrontLeft] = 0;
	motor[BaseBackRight] = 0;
	motor[BaseFrontRight] = 0;
	arm(0);
}

//------------------------Declare Special UserMade Autonomous Methods-------------------------

//This is the autonomous for getting the cube on the (left?) side during competition environments.
void cubeAutonomousLeft()
{
	resetMotorEncoders();
	driveForward(127, 200);
	wait1Msec(100);
	resetMotorEncoders();
	driveBackward(127, 200);
	wait1Msec(250);
	resetMotorEncoders();
	driveForward(127, 700);
	wait1Msec(250);
	resetMotorEncoders();
	liftArm(100, 450);
	arm(10);
	resetMotorEncoders();
	rotateRight(50, 350);
	resetMotorEncoders();
	driveBackwardLift(100, 900, 80, 750);
	resetMotorEncoders();
	wait1Msec(2500);
	lowerArm(80, 800);
	resetMotorEncoders();
	wait1Msec(300);
	driveForward(127, 100);
	driveBackward(127, 200);
	wait1Msec(300);
	//resetMotorEncoders;
	driveForward(127, 750);
	wait1Msec(250);
	resetMotorEncoders();
	driveBackwardLift(20, 25, 100, 300);
	resetMotorEncoders();
	driveBackwardLift(100, 1000, 90, 1100);
	resetMotorEncoders();
	lowerArm(75, 800);
	wait1Msec(400);
	driveForward(127, 100);
	driveBackward(127, 100);
	wait1Msec(300);
	resetMotorEncoders();
	driveForward(127, 1050);
	wait1Msec(350);
	resetMotorEncoders();
	liftArm(127, 400);
	driveBackwardLift(127,1200,70, 1400);
	resetMotorEncoders();
}

//This is the autonomous for getting the cube on the (right?) side during competition environments.
void cubeAutonomousRight()
{
	resetMotorEncoders();
	driveForward(127, 200);
	wait1Msec(100);
	resetMotorEncoders();
	driveBackward(127, 200);
	wait1Msec(250);
	resetMotorEncoders();
	driveForward(127, 700);
	wait1Msec(250);
	resetMotorEncoders();
	liftArm(100, 450);
	arm(10);
	resetMotorEncoders();
	rotateLeft(50, 350);
	resetMotorEncoders();
	driveBackwardLift(100, 900, 80, 750);
	resetMotorEncoders();
	wait1Msec(2500);
	lowerArm(80, 800);
	resetMotorEncoders();
	wait1Msec(300);
	driveForward(127, 100);
	driveBackward(127, 200);
	wait1Msec(300);
	//resetMotorEncoders;
	driveForward(127, 750);
	wait1Msec(250);
	resetMotorEncoders();
	driveBackwardLift(20, 25, 100, 300);
	resetMotorEncoders();
	driveBackwardLift(100, 1000, 90, 1100);
	resetMotorEncoders();
	lowerArm(75, 800);
	wait1Msec(400);
	driveForward(127, 100);
	driveBackward(127, 100);
	wait1Msec(300);
	resetMotorEncoders();
	driveForward(127, 1050);
	wait1Msec(350);
	resetMotorEncoders();
	liftArm(127, 400);
	driveBackwardLift(127,1200,70, 1400);
	resetMotorEncoders();
}

//This is the autonomous for getting stars on the left side fence during competition environments.
void fenceStarAutonomousLeft()
{

}

//This is the autonomous for getting stars on the right side fence during competition environments.
void fenceStarAutonomousRight()
{

}

//This is the autonomous for getting stars in the back on the left side during competition environments.
void backStarAutonomousLeft()
{
	resetMotorEncoders();
	liftArm(127, 20);
	driveForward(127, 300);
	resetMotorEncoders();
	driveBackward(127, 400);
	wait1Msec(600);
	driveForward(127,650);
	liftArm(127, 800);
	arm(20);
	resetMotorEncoders();
	driveBackward(127, 1400);
	resetMotorEncoders();
	rotateRight(80, 280);
	wait1Msec(300);
	resetMotorEncoders();
	driveBackward(127, 900);
	driveBackwardLift(127, 1800, 127, 800);
	resetMotorEncoders();
	lowerArm(127, 1100);
	wait1Msec(600);
	driveForward(127, 300);
	resetMotorEncoders();
	driveBackward(127, 400);
	wait1Msec(600);
	resetMotorEncoders();
	rotateRight(127, 100);
	driveForward(127, 700);
	liftArm(127, 700);
	resetMotorEncoders();
	driveBackward(127, 700);
	driveBackwardLift(127, 400, 127, 800);
}

//This is the autonomous for getting stars in the back on the right side during competition environments.
void backStarAutonomousRight()
{
	resetMotorEncoders();
	liftArm(127, 60);
	driveForward(127, 300);
	resetMotorEncoders();
	driveBackward(127, 400);
	wait1Msec(600);
	driveForward(127,650);
	liftArm(127, 800);
	arm(20);
	resetMotorEncoders();
	driveBackward(127, 1400);
	resetMotorEncoders();
	rotateLeft(80, 160);
	wait1Msec(300);
	resetMotorEncoders();
	driveBackward(127, 900);
	driveBackwardLift(127, 1800, 127, 800);
	resetMotorEncoders();
	lowerArm(127, 1100);
	wait1Msec(600);
	driveForward(127, 300);
	resetMotorEncoders();
	driveBackward(127, 400);
	wait1Msec(600);
	resetMotorEncoders();
	rotateLeft(127, 70);
	driveForward(127, 600);
	liftArm(127, 700);
	resetMotorEncoders();
	driveBackward(127, 700);
	driveBackwardLift(127, 900, 127, 1000);
}

//This is the autonomous for skills program 1
void skillsProgram1()
{
	driveBackward(127, 550);
	resetMotorEncoders();
	driveForwardLift(20, 40, 127, 400);
	resetMotorEncoders();
	wait1Msec(2000);
	driveBackwardLift(127, 1300, 95, 825);
	wait1Msec(100);
	resetMotorEncoders();
	lowerArm(60, 500);
	resetMotorEncoders();
	driveForwardLower(80, 550, 20, 225);
	wait1Msec(1500);
	resetMotorEncoders();
	driveBackwardLift(127, 1300, 95, 925);
	wait1Msec(100);
	resetMotorEncoders();
	lowerArm(60, 500);
	resetMotorEncoders();
	driveForwardLower(80, 550, 40, 225);
	wait1Msec(1500);
	resetMotorEncoders();
	driveBackwardLift(127, 1600, 90, 950);
	resetMotorEncoders();
	wait1Msec(100);
	resetMotorEncoders();
	lowerArm(60, 600);
	wait1Msec(250);
	resetMotorEncoders();
	driveForwardLower(127, 375, 50, 175);
	wait1Msec(200);
	resetMotorEncoders();
	rotateLeft(75, 325);
	resetMotorEncoders();
	driveBackwardLower(127, 500, 40, 100);
	wait1Msec(250);
	resetMotorEncoders();
	driveForward(100, 3000);
	wait1Msec(250);
	resetMotorEncoders();
	liftArm(100, 650);
	wait1Msec(100);
	resetMotorEncoders();
	driveBackward(70, 100);
	wait1Msec(250);
	resetMotorEncoders();
	rotateRight(75, 200);
	wait1Msec(250);
	resetMotorEncoders();
	driveBackwardLift(127, 800, 60, 950);
	resetMotorEncoders();
	lowerArm(70, 1200);
	resetMotorEncoders();
	driveForwardLower(127, 650, 70, 500);
	wait1Msec(500);
	resetMotorEncoders();
	driveForward(127, 200);
	resetMotorEncoders();
	liftArm(70, 250);
	wait1Msec(250);
	resetMotorEncoders();
	driveBackwardLift(127, 900, 80, 1600);
	resetMotorEncoders ();
	wait1Msec(100);
	lowerArm(60, 1400);
	resetMotorEncoders();
	wait1Msec(1000);
	rotateLeft(127, 75);
	resetMotorEncoders();
	driveForward(127, 600);
	wait1Msec(250);
	resetMotorEncoders();
	liftArm(60, 400);
	wait1Msec(250);
	resetMotorEncoders();
	driveBackwardLift(127, 900, 60, 900);
	resetMotorEncoders();
	wait1Msec(250);
	lowerArm(60, 600);
	resetMotorEncoders();
	driveForward(127, 400);
	resetMotorEncoders();
	rotateLeft(100, 900);
	resetMotorEncoders();
	driveBackward(127, 700);
	resetMotorEncoders();
	wait1Msec(250);
	rotateRight(127,400);
	resetMotorEncoders();
	wait1Msec(250);
	driveBackward(127, 800);
	resetMotorEncoders();
	rotateRight(127, 300);
	resetMotorEncoders();
	wait1Msec(250);
	driveBackward(127, 300);
	resetMotorEncoders();
	rotateLeft(127, 200);
	resetMotorEncoders();
	driveBackwardLift(127, 100, 60, 400);
	resetMotorEncoders();
	liftArm(70, 950);
	resetMotorEncoders();
	driveForward(127, 100);
	resetMotorEncoders();
	driveForwardLower(127, 500, 60, 1100);
	resetMotorEncoders();
}

//This is the autonomous for hanging on the left side
void hangAutonomousLeft()
{

}

//This is the autonomous for hanging on the right side
void hangAutonomousRight()
{

}

//Outputs what program will run(based on potentiometers) on the lcd screen
void screenProgramName()
{
	if(SensorValue[UpperPent] >= 2048)
	{
		if(SensorValue[LowerPent] >= 3070)
		{
			displayLCDCenteredString(0, "Skills");
			displayLCDCenteredString(1, "Program 1");
		}
		else if(SensorValue[LowerPent] >= 2047)
		{
			displayLCDCenteredString(0, "Autonomous");
			displayLCDCenteredString(1, "Disabled");
		}
		else if(SensorValue[LowerPent] >= 1023)
		{
			displayLCDCenteredString(0, "Autonomous");
			displayLCDCenteredString(1, "Hang Left");
		}
		else
		{
			displayLCDCenteredString(0, "Autonomous");
			displayLCDCenteredString(1, "Hang Right");
		}
	}
	else if(SensorValue[UpperPent] <= 2047)
	{
		if(SensorValue[LowerPent] >= 3412)
		{
			displayLCDCenteredString(0, "Competition");
			displayLCDCenteredString(1, "Left Cube");
		}
		else if(SensorValue[LowerPent] >= 2730)
		{
			displayLCDCenteredString(0, "Competition");
			displayLCDCenteredString(1, "Right Cube");
		}
		else if(SensorValue[LowerPent] >= 2048)
		{
			displayLCDCenteredString(0, "Competition");
			displayLCDCenteredString(1, "Left Fence Star");
		}
		else if(SensorValue[LowerPent] >= 1365)
		{
			displayLCDCenteredString(0, "Competition");
			displayLCDCenteredString(1, "Right Fence Star");
		}
		else if(SensorValue[LowerPent] >= 683)
		{
			displayLCDCenteredString(0, "Competition");
			displayLCDCenteredString(1, "Left Back Star");
		}
		else
		{
			displayLCDCenteredString(0, "Competition");
			displayLCDCenteredString(1, "Right Back Star");
		}
	}
}

//---------------------------------------Pre-Autonomous---------------------------------------

void pre_auton()
{
	//Tells Autonomus to stop between competition programs
	bStopTasksBetweenModes = true;
	//Clears and preps LCD screen
	clearLCDLine(0);
	clearLCDLine(1);
	bLCDBacklight = true;
	//Reset Motor Encoders
	resetMotorEncoders();

}

//-----------------------------------------Autonomous-----------------------------------------

task autonomous()
{
	screenProgramName();
	if(SensorValue[UpperPent] >= 2048)
	{
		if(SensorValue[LowerPent] >= 3070)
		{
			//Runs Skills Program 1
			skillsProgram1();
		}
		else if(SensorValue[LowerPent] >= 2047)
		{
			//Run nothing (This is the disabled position)
		}
		else if(SensorValue[LowerPent] >= 1023)
		{
			//Runs Hang Autonomous Left
			hangAutonomousLeft();
		}
		else
		{
			//Runs Hang Autonomous Left
			hangAutonomousRight();
		}
	}
	else if(SensorValue[UpperPent] <= 2047)
	{
		if(SensorValue[LowerPent] >= 3412)
		{
			//Runs Left Cube Autonomous
			cubeAutonomousLeft();
		}
		else if(SensorValue[LowerPent] >= 2730)
		{
			//Runs Right Cube Autonomous
			cubeAutonomousRight();
		}
		else if(SensorValue[LowerPent] >= 2048)
		{
			//Runs Left Fence Star Autonomous
			fenceStarAutonomousLeft();
		}
		else if(SensorValue[LowerPent] >= 1365)
		{
			//Runs Right Fence Star Autonomous
			fenceStarAutonomousRight();
		}
		else if(SensorValue[LowerPent] >= 683)
		{
			//Runs Right Back Star Autonomous
			backStarAutonomousLeft();
		}
		else
		{
			//Runs Right Back Star Autonomous
			backStarAutonomousRight();
		}
	}
	//AutonomousCodePlaceholderForTesting();  //Disable During COMP or real testing
}



//----------------------------------------User Control----------------------------------------

task usercontrol()
{
	string mainBattery, backupBattery;
	int lel = 0;
	while (true)
	{
		//Output the currently selected autonomous name or battery level
		if(nLCDButtons == 1)
		{
			sprintf(mainBattery, "Main: %1.2f%c", nImmediateBatteryLevel/1000.0,'V');
			displayLCDCenteredString(0, mainBattery);
			sprintf(backupBattery, "Backup: %1.2f%c", BackupBatteryLevel/1000.0, 'V');
			displayLCDCenteredString(1, backupBattery);
		}
		else if(nLCDButtons == 2)
		{
			if(lel == 0){
			 displayLCDCenteredString(0, "LEL LEL LEL LEL ");
			 displayLCDCenteredString(1, " LEL LEL LEL LEL");
			 lel = 1;
			}
			else if(lel == 1)
			{
				displayLCDCenteredString(0, " LEL LEL LEL LEL");
				displayLCDCenteredString(1, "L LEL LEL LEL LE");
				lel = 2;
			}
			else if(lel == 2)
			{
				displayLCDCenteredString(0, "L LEL LEL LEL LE");
				displayLCDCenteredString(1, "EL LEL LEL LEL L");
				lel = 3;
			}
			else if(lel == 3)
			{
				displayLCDCenteredString(0, "EL LEL LEL LEL L");
				displayLCDCenteredString(1, "LEL LEL LEL LEL ");
				lel = 0;
			}
			wait1Msec(400);
		}
		else
		{
			screenProgramName();
		}

		//Remote Base (Tank Control)
		motor[BaseFrontRight] = vexRT[Ch2];
		motor[BaseBackRight] = vexRT[Ch2];
		motor[BaseFrontLeft] = vexRT[Ch3];
		motor[BaseBackLeft] = vexRT[Ch3];

		//Remote Arm Control
		if(vexRT[Btn6U] == true && vexRT[Btn6D] == false)
		{
			arm(127);
		}
		else if(vexRT[Btn6U] == false && vexRT[Btn6D] == true)
		{
			arm(-127);
		}
		else
		{
			arm(0);
		}
		//UserControlCodePlaceholderForTesting(); //Disable During COMP or real testing
	}
}
